
import hpjava.* ;


class Producer extends Thread {
  Port prev, next, out ;
  int id ;

  public Producer(Port prev, Port next, int id, Port out) {
    this.prev = prev ;
    this.next = next ;
    this.out  = out  ;

    this.id = id ;
  }

  public Producer(Port prev, Port next, int id) {
    this.prev = prev ;
    this.next = next ;
    this.out  = new Port() ;

    this.id = id ;
  }

  public void run() {
//    if(id == 0 ) {
//      out.sendInt(id) ;
//      next.sendChan(out) ;
//    }
//    while(true) {
//      prev.recvChan(out) ;
//      out.sendInt(id) ;
//      next.sendChan(out) ;
//    }
    if(id == 0)
      for(int i = 0 ; i < 20 ; i++) {
	out.sendInt(id) ;
	next.sendChan(out) ;
	prev.recvChan(out) ;
      }
    else
      for(int i = 0 ; i < 20 ; i++) {
	prev.recvChan(out) ;
	out.sendInt(id) ;
	next.sendChan(out) ;
      }
  }
}


class Consumer extends Thread {
  Port prev, next, in ;
  int id ;

  public Consumer(Port prev, Port next, int id, Port in) {
    this.prev = prev ;
    this.next = next ;
    this.in   = in  ;

    this.id = id ;
  }

  public Consumer(Port prev, Port next, int id) {
    this.prev = prev ;
    this.next = next ;
    this.in   = new Port() ;

    this.id = id ;
  }

  public void run() {
//    if(id == 0) {
//      System.out.println("Consumer " + id + " got " + in.recvInt()) ;
//      prev.sendChan(in) ;
//    }
//    while(true) {
//      next.recvChan(in) ;
//      System.out.println("Consumer " + id + " got " + in.recvInt()) ;
//      prev.sendChan(in) ;
//    }
    if(id == 0 )
      for(int i = 0 ; i < 15 ; i++) {
	System.out.println("Consumer " + id + " got " + in.recvInt()) ;
	prev.sendChan(in) ;
	next.recvChan(in) ;
      }
    else
      for(int i = 0 ; i < 15 ; i++) {
	next.recvChan(in) ;
	System.out.println("Consumer " + id + " got " + in.recvInt()) ;
	prev.sendChan(in) ;
      }
  }
}


public class Eg5 {
  static final int n = 3 ;
  static final int m = 4 ;

  public static void main(String args[]) {

    // Create output channel

    Port R = new Port() ;
    Port S = new Port() ;

    Port.channel(R, S) ;


    // Create a ring of channels

    Port P [] = new Port [n] ;
    Port Q [] = new Port [n] ;

    for(int i = 0 ; i < n ; i++) {
      P [i] = new Port() ;
      Q [i] = new Port() ;
    }

    for(int i = 0 ; i < n ; i++)
      Port.channel(P [i], Q [(i + 1) % n]) ;

    // Fork a ring of producers

    (new Producer(Q [0], P [0], 0, R)).start() ;
    for(int i = 1 ; i < n ; i++)
      (new Producer(Q [i], P [i], i)).start() ;


    // Create another ring of channels

    Port T [] = new Port [m] ;
    Port U [] = new Port [m] ;

    for(int i = 0 ; i < m ; i++) {
      T [i] = new Port() ;
      U [i] = new Port() ;
    }

    for(int i = 0 ; i < m ; i++)
      Port.channel(U [i], T [(i + 1) % m]) ;

    // Fork a ring of consumers

    (new Consumer(T [0], U [0], 0, S)).start() ;
    for(int i = 1 ; i < m ; i++)
      (new Consumer(T [i], U [i], i)).start() ;

  }
}


